<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [sip.js](./sip.js.md) &gt; [UserAgentCore](./sip.js.useragentcore.md) &gt; [replyStateless](./sip.js.useragentcore.replystateless.md)

## UserAgentCore.replyStateless() method

A stateless UAS is a UAS that does not maintain transaction state. It replies to requests normally, but discards any state that would ordinarily be retained by a UAS after a response has been sent. If a stateless UAS receives a retransmission of a request, it regenerates the response and re-sends it, just as if it were replying to the first instance of the request. A UAS cannot be stateless unless the request processing for that method would always result in the same response if the requests are identical. This rules out stateless registrars, for example. Stateless UASs do not use a transaction layer; they receive requests directly from the transport layer and send responses directly to the transport layer. https://tools.ietf.org/html/rfc3261\#section-8.2.7

<b>Signature:</b>

```typescript
replyStateless(message: IncomingRequestMessage, options: ResponseOptions): OutgoingResponse;
```

## Parameters

|  Parameter | Type | Description |
|  --- | --- | --- |
|  message | <code>IncomingRequestMessage</code> | Incoming request message to reply to. |
|  options | <code>ResponseOptions</code> |  |

<b>Returns:</b>

`OutgoingResponse`

